"""
Django settings for samplesite project.

Generated by 'django-admin startproject' using Django 3.0.2.

For more information on this file, see
https://docs.djangoproject.com/en/3.0/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/3.0/ref/settings/
"""

import os
from social_core.backends.vk import VKOAuth2

# Build paths inside the project like this: os.path.join(BASE_DIR, ...)
BASE_DIR = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))

# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/3.0/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = '3f6@=qp-ne2r+%$xvtk^w4)p&un#=fo*6+u6zmr^+qtzh5zvt0'

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = True

ALLOWED_HOSTS = []

# Application definition

INSTALLED_APPS = [

    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
    'bboard',
    'django_extensions',
    'captcha',
    'precise_bbcode',
    'bootstrap4',
    'testapp',
    'django_cleanup',  # Удаление ненужных файлов
    'easy_thumbnails',  # Создание миниатюр
    'social_django',
    'rest_framework',
    'corsheaders',
]

MIDDLEWARE = [
    'django.middleware.http.ConditionalGetMiddleware',
    # Кэшиование на стороне клиента, не работает без посредников для кеширования на сервере
    'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'corsheaders.middleware.CorsMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
    'django.middleware.cache.UpdateCacheMiddleware',  # Cache
    'django.middleware.cache.FetchFromCacheMiddleware',  # Cache
    'bboard.middlewares.RubricMiddleware'  # Свой посредник
]

ROOT_URLCONF = 'samplesite.urls'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [
            os.path.join(BASE_DIR, 'templates')
        ],
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
                'social_django.context_processors.backends',  # vk login
                'social_django.context_processors.login_redirect',  # vk login
                'bboard.context_processors.rubrics'  # Свой обработчик контекста
            ],
        },
    },
]

WSGI_APPLICATION = 'samplesite.wsgi.application'

# Database
# https://docs.djangoproject.com/en/3.0/ref/settings/#databases

DATABASES = {
    'default': {
        'ENGINE': 'django.db.backends.sqlite3',
        'NAME': os.path.join(BASE_DIR, 'db.sqlite3'),
    }
}

# Password validation
# https://docs.djangoproject.com/en/3.0/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]

# Internationalization
# https://docs.djangoproject.com/en/3.0/topics/i18n/

LANGUAGE_CODE = 'ru'

TIME_ZONE = 'UTC'

USE_I18N = True

USE_L10N = True

USE_TZ = True

# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/3.0/howto/static-files/

STATIC_URL = '/static/'
LOGOUT_REDIRECT_URL = 'index'

CAPTCHA_CHALLENGE_FUNCT = 'captcha.helpers.math_challenge'

MEDIA_ROOT = os.path.join(BASE_DIR, 'media')
MEDIA_URL = '/media/'

THUMBNAIL_ALIASES = {
    'bboard.Bb.picture': {
        'default': {
            'size': (500, 300),
            'crop': 'scale',
        },
    },
    'testapp': {
        'default': {
            'size': (300, 400),
            'crop': 'smart',
            'bw': True,
        },
    },
    '': {
        'default': {
            'size': (180, 240),
            'crop': 'scale',
        },
        'big': {
            'size': ()
        }
    }
}

new_validator = [{'NAME': 'samplesite.my_password_validators.NoForbiddenCharsValidator',
                  'OPTIONS': {'forbidden_chars': (' ', ':', ';')}}]
# Сам словарь AUTH_PASSWORD_VALIDATORS используется автоматически далеко не везде, например чтобы прверить пароль введенный в форму нужно сделать проверку самомму, глава 20.4.3
AUTH_PASSWORD_VALIDATORS += new_validator

# vk login
AUTHENTICATION_BACKENDS = [
    'social_core.backends.vk.VKOAuth2',
    'django.contrib.auth.backends.ModelBackend'
]

SOCIAL_AUTH_VK_OAUTH2_KEY = '7344161'
SOCIAL_AUTH_VK_OAUTH2_SECRET = '2JE4OYyqyWenV2S7C3nQ'

EMAIL_HOST = 'smtp.yandex.ru'
EMAIL_PORT = 465
EMAIL_HOST_USER = 'ValSLTest@yandex.by'
EMAIL_HOST_PASSWORD = 'etereg14'
EMAIL_USE_SSL = True

ADMIN = [
    ('valid', 'valid.saley@gmail.com')
]

# Кэширование
CACHES = {
    'default': {
        'BACKEND': 'django.core.cache.backends.db.DatabaseCache',
        'LOCATION': 'cahce_table',
        'TIMEOUT': 120,
        'OPTIONS': {
            'MAX_ENTRIES': 200,
        }
    }
}

CORS_ORIGIN_ALLOW_ALL = True


def info_filter(message):  # message экземпляр класса LogRecord
    return message.levelname == 'INFO'


LOGGING = {
    'version': 1,
    'disable_existing_loggers': True,
    'formatters': {
        'simple': {
            'format': '[%(asctime)s] %(levelname)s: %(message)s',
            'datefmt': '%Y.%m.%d %H:%M:%S',
        },
    },
    'filters': {
        'require_debug_false': {
            '()': 'django.utils.log.RequireDebugFalse',
        },
        'require_debug_true': {
            '()': 'django.utils.log.RequireDebugTrue',
        },
        'info_filter': {
            '()': 'django.utils.log.CallbackFilter', 'callback': info_filter,
        },
    },
    'handlers': {
        'console_dev': {
            'class': 'logging.StreamHandler',
            'formatter': 'simple',
            'filters': ['require_debug_true'],
        },
        'console_prod': {
          'class': 'logging.StreamHandler',
          'formatter': 'simple',
          'level': 'ERROR',
          'filters': ['require_debug_false'],
        },
        'file': {
            'class': 'logging.handlers.RotatingFileHandler',
            'maxBytes': 1048576,
            'filename': '/home/valid/Projects/Django_dronov/log.log',
            'backupCount': 10,
            'formatter': 'simple',
        },

    },
    'loggers': {
        'django': {
            'handlers': ['console_dev', 'console_prod'],
        },
        'django.server': {
            'handlers': ['file'],
            'level': 'INFO',
            'propagate': True,
        },
    }
}


#  Удаленные примеры обработчиков
# 'file': {
#             'class': 'logging.handlers.TimedRotatingFileHandler',
#             'level': 'INFO',
#             'filename': '/home/valid/Projects/Django_dronov/log.log',
#             'when': 'D',
#             'interval': 10,
#             'utc': True,
#             'backupCount': 10,


# 'file2': {
#             'class': 'logging.handlers.SMTPHandler',
#             'mailhost': 'smtp.yandex.ru',
#             'fromaddr': 'DjangoAdmin',
#             'toaddrs': ['valid.saley@gmail.com'],
#             'subject': 'Troubles with site',
#             'credentials': ('ValSLTest@yandex.by', 'etereg14'),
#             'secure': (),
#         },